package io.tswf.minecraft.blockventure.core.transmutation

import groovy.transform.CompileStatic
import groovy.util.logging.Slf4j
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.ClassReference
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.MethodDescription
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.Self
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.Transmute
import io.tswf.minecraft.blockventure.core.network.packet.ClientNetworkPlayPacketWrapper
import io.tswf.minecraft.blockventure.core.network.packet.NetworkPlayPacketWrapperCreator
import io.tswf.minecraft.blockventure.core.network.packet.ServerNetworkPlayPacketWrapper
import io.tswf.minecraft.blockventure.core.view.ViewNetworkStatePacketHandler
import io.tswf.minecraft.blockventure.core.view.ViewNetworkStatePacketHandlerInitializer
import net.minecraft.network.NetworkSide
import net.minecraft.network.NetworkState
import net.minecraft.network.PacketByteBuf
import net.minecraft.network.packet.Packet

import java.util.function.Function

@Slf4j
@CompileStatic
class TransmutationPacketHandlerInitializer {

//    @Transmute(
//            targetClass = @ClassReference(descriptor = 'Lnet/minecraft/network/NetworkState$PacketHandlerInitializer;'),
//            targetMethod = @MethodDescription(
//                    name = "setup",
//                    parameterTypes = [ @ClassReference(NetworkSide), @ClassReference(descriptor = 'Lnet/minecraft/network/NetworkState$PacketHandler;') ],
//                    returnType = @ClassReference(descriptor = 'Lnet/minecraft/network/NetworkState$PacketHandlerInitializer;')
//            )
//    )
//    static void injectWrapperPackets(NetworkSide networkSide, Object packetHandler) {
//        if (networkSide == NetworkSide.)
//        def viewPacketHandler = (ViewNetworkStatePacketHandler) packetHandler
//
//        log.info("Registering ${ClientNetworkPlayPacketWrapper.name} packet on side ${networkSide.name()}!")
//
//        viewPacketHandler.callRegister(
//                ClientNetworkPlayPacketWrapper as Class,
//                { PacketByteBuf buf -> NetworkPlayPacketWrapperCreator.createWrapperForPlayPacket(buf, false) } as Function<PacketByteBuf, Packet>
//        )
//
//        log.info("Registering ${ServerNetworkPlayPacketWrapper.name} packet on side ${networkSide.name()}!")
//
//        viewPacketHandler.callRegister(
//                ServerNetworkPlayPacketWrapper as Class,
//                { PacketByteBuf buf -> NetworkPlayPacketWrapperCreator.createWrapperForPlayPacket(buf, true) } as Function<PacketByteBuf, Packet>
//        )
//    }

}
