package io.tswf.minecraft.blockventure.core.view

import io.tswf.groovy.bettergroovy.asm.view.annotation.OnConflict
import io.tswf.groovy.bettergroovy.asm.view.annotation.View
import io.tswf.groovy.bettergroovy.asm.view.meta.ViewConflictResolveStrategy
import net.minecraft.network.NetworkSide
import net.minecraft.network.NetworkState

@View(targetClasses = NetworkState)
interface ViewNetworkState {

    @OnConflict(ViewConflictResolveStrategy.WARNING)
    Map<NetworkSide, Object> getPacketHandlers()
}