package io.tswf.minecraft.blockventure.core.view

import io.tswf.groovy.bettergroovy.asm.view.annotation.MethodInvoke
import io.tswf.groovy.bettergroovy.asm.view.annotation.View
import net.minecraft.network.PacketByteBuf
import net.minecraft.network.packet.Packet

import java.util.function.Function

@View(targetInternalNames = 'net/minecraft/network/NetworkState$PacketHandler')
interface ViewNetworkStatePacketHandler {

    @MethodInvoke(name = "register", desc = '(Ljava/lang/Class;Ljava/util/function/Function;)Lnet/minecraft/network/NetworkState$PacketHandler;')
    Object callRegister(Class<Packet> type, Function<PacketByteBuf, Packet> packetFactory)
}